		bits 16

%define _DRAW_ASM_		
%include "defs.inc"

global ShiftPal, InitScoreBar, DrawScoreBar, Draw
extern ScoreBarDirty, shiftDelay, shiftCount, shiftDisplac
extern msg, pal, monsters, monstNum, player, score, lives
extern tileDraw, objDraw, DoSound, SbPoll

SEGMENT _TEXT PUBLIC ALIGN=2 CLASS=CODE

; -=( InitScoreBar )=--------------------------------------------------------
InitScoreBar:	
	pusha
	MemCpy msg, "Lives: 00   Score: 000000", 0
	popa
	ret
		
; -=( ShiftPal )=-----------------------------------------------------------
; -=( Shiftet die Farben 251 bis 254 (hex: FB,FE) )=-
; --------------------------------------------------------------------------
ShiftPal:
	pushx ax,si

	mov al,[shiftCount]
	inc al
	mov [shiftCount],al
	cmp al,[shiftDelay]
	jnz .bye

	xor al,al
	mov [shiftCount],al

	mov al,251
	mov ah,[shiftDisplac]
	add ah,al

.setIt:	push ax
	mov al,ah
	xor ah,ah
	mov si,ax			;si = ax*3 = ax << 2 - ax
	shl si,2
	sub si,ax
	add si,pal			;Index in pal mit Displacement
	pop ax

	call SetColor			;Farbe ohne Displ. setzen

	inc ah
	cmp ah,254			;ah > 254?
	jna .notA
	mov ah,251			;Wrappen

.notA:	inc al
	cmp al,254			;al <= 254?
	jbe .setIt			;Loopen

	mov ah,[shiftDisplac]
	inc ah
	and ah,00000011b		;Displ. %= 4
	mov [shiftDisplac],ah		;Zurckschreiben
	
.bye:	popx si,ax
	ret
	
	
; -=( DrawScoreBar )=-------------------------------------------------------
; --------------------------------------------------------------------------
DrawScoreBar:
	pushx cx,dx,si

	xor cx,cx
	mov dx,SCREEN_H-14
	mov si,msg
	call OutStr

	popx si,dx,cx
	ret
	
	
; -=( Draw )=---------------------------------------------------------------
; -=( Zeichnet Map, Player, Monster und ScoreBar )=-
; --------------------------------------------------------------------------
Draw:	pusha

	;Jedes Tile anzeigen
	mov bx,MAP_SIZE-1		;bx = index

	mov di, MAP_HEIGHT-1		;di,dx = y
	mov dx,(MAP_HEIGHT-1) * TILE_HEIGHT

.yLoop:	mov cx,(MAP_WIDTH-1) * TILE_WIDTH
	mov si, MAP_WIDTH-1		;cx,si = x

.xLoop:	call tileDraw
	sub cx,TILE_WIDTH
	dec bx
	dec si
	jns .xLoop
	sub dx,TILE_HEIGHT
	dec di
	jns .yLoop

	lea si,[player]			;Player zeichnen
	xor cx,cx
	mov dx,cx
	call objDraw

	lea si,[monsters]		;Alle Monster zeichnen
	mov ax,[monstNum]
	or ax,ax
	jz .monDon
.drawMon:
	xor cx,cx
	mov dx,cx
	call objDraw
	add si,obj_size
	dec ax
	jnz .drawMon

.monDon cmp byte [ScoreBarDirty],0
	je .NoBar
	dec byte [ScoreBarDirty]
	or bp,0xffff
	call DrawScoreBar
.NoBar	call FlipPage
	call VSync
	call ShiftPal
	call DoSound

	popa
	ret