		bits 16

%define _EDITOR_ASM_
%include "defs.inc"

global Editor,Sure,ClearScoreBar,Input,PromptFilename,PrintError,DispHelp
extern editHelp, scan2asc, editorPosX, editorPosY, editorFrame
extern ScoreBarDirty, keys, isKey, isEsc, lastKey, plKeyUp, plKeyLeft
extern plKeyDown, plKeyRight, plKeyJump, monstNum, player, lives, playerDead
extern score, tileTable, tilSlim, tilPac, tilBall, tilMan, tilBg, tilBlk
extern tilAppr, tilDsAp, mapData, mapRefresh, level, levels, levelDone
extern maxLev, msg
extern Draw, DrawScoreBar, InitScoreBar, ShiftPal, objSetRefresh, SetStart
extern InitLev, Game


SEGMENT _TEXT PUBLIC ALIGN=2 CLASS=CODE

; -=( Input )=--------------------------------------------------------------
; -=( Liest einen String von der Tastatur, mit Echo )=-
; -=( IN: cx - x, dx - y, bx - max. Chars, ds:di - buffer )=-
; --------------------------------------------------------------------------
Input:	pusha
	push es
	push ds
	pop es
	mov bp,cx
.GetChar:
	call FlipPage
	call VSync
	call VSync
	call VSync

.IsChr:	mov byte [cs:isKey],0
.WtChr:	cmp byte [cs:isKey],0
	je .WtChr

	mov al,[cs:lastKey]
	cmp al,KEY_LSHIFT
	je .IsChr
	cmp al,KEY_RSHIFT
	je .IsChr

	push bx
	mov bx,scan2asc
	xlatb
	pop bx

	cmp al,13			;; Return ;;
	jne .NoRet
	xor al,al
	stosb
	jmp short .Bye

.NoRet:	cmp al,14			;; BackSpace ;;
	jne .NoBS
	cmp cx,bp
	je .GetChar

	sub cx,8
	mov al,' '
	call OutChar
	call FlipPage
	sub cx,8
	call OutChar
	sub cx,8
	inc bx
	dec di

	jmp short .GetChar

.NoBS:	or bx,bx
	jz .GetChar
	dec bx

	call OutChar
	call FlipPage
	sub cx,8
	call OutChar
	stosb

	jmp short .GetChar

.Bye:	pop es
	popa
	ret

; -=( ClearScoreBar )=-------------------------------------------------------
ClearScoreBar:
	pusha
	push es
	push ds
	pop es
	mov di,msg
	mov al,' '
	mov cx,40
	rep stosb
	xor al,al
	stosb

	pop es
	popa 
	ret

; -=( Sure )=---------------------------------------------------------------
; -=( Gibt 'Sure?' aus und wartet auf Tastendruck, springt zu %1 wenn )=-
; -=( was anderes als Y oder Z gedrueckt ist )=-
; --------------------------------------------------------------------------
Sure:	pusha

	mov byte [cs:Color],251
	call ClearScoreBar
	MemCpy msg,"Wirklich?"

	mov byte [cs:isKey],0
.WtKey	call DrawScoreBar
	call FlipPage
	call VSync
	call ShiftPal
	cmp byte [cs:isKey],0
	je .WtKey

	call ClearScoreBar
	call DrawScoreBar
	call FlipPage
	call DrawScoreBar
	call InitScoreBar

	cmp byte [cs:keys+KEY_J],0
	mov byte [cs:keys+KEY_J],0
	stc
	jne .Done
	cmp byte [cs:keys+KEY_Y],0
	mov byte [cs:keys+KEY_Y],0
	stc
	jne .Done
	cmp byte [cs:keys+KEY_Z],0
	mov byte [cs:keys+KEY_Z],0
	stc
	jne .Done

	clc
.Done:	mov byte [cs:Color],0
	popa
	ret

; -=( PromptFilename )=-----------------------------------------------------
; -=( Fragt nach einem Dateinamen in der ScoreBar )=-
; -=( OUT: msg - Dateiname )=-
; --------------------------------------------------------------------------
PromptFilename:
	pusha
	call ClearScoreBar
	MemCpy msg, "Dateiname eingeben:"

	mov byte [cs:Color],251
	call DrawScoreBar
	call FlipPage
	call DrawScoreBar

	mov bx,13
	mov cx,8*20
	mov dx,SCREEN_H-14
	mov di,msg

	call Input
	popa
	ret
	
; -=( PrintError )=--------------------------------------------------------
; -=( Gibt "Error!" in der ScoreBar aus )=-
; -------------------------------------------------------------------------
PrintError:
	pusha

	call ClearScoreBar	
	MemCpy msg,"Fehler!"
	call DrawScoreBar
	call FlipPage
	call DrawScoreBar

	popa
	ret
	
; -=( DispHelp )=-----------------------------------------------------------
; -=( Zeigt einen Hilfetext an    IN: si - Text )=-
; --------------------------------------------------------------------------
DispHelp:
	pusha	
	
	call FlipPage				;Bildschirm lschen
	call ClearScreen
	xor cx,cx
	xor dx,dx
	or bp,0xffff
	call OutStr
	call FlipPage
	
	mov byte [cs:isKey],0			;Auf Taste warten
.keyLp	cmp byte [cs:isKey],0
	je .keyLp
	inc bp
		
	call ClearScreen			;Bildschirm lschen
	call FlipPage
	call ClearScreen
	
	popa
	ret

; -=( Editor )=-------------------------------------------------------------
; -=( Einfacher Level-Editor )=-
; --------------------------------------------------------------------------
Editor:	push ds
	pop es
	call InitLev
	mov word [editorPosX],0
	mov word [editorPosY],0
	mov word [monstNum],0
	mov word [tileTable+15*2],tilSlim
	mov word [tileTable+17*2],tilPac
	mov word [tileTable+18*2],tilBall
	mov word [tileTable+20*2],tilMan
	mov word [tileTable+21*2],tilAppr
	mov word [tileTable+22*2],tilDsAp
	mov word [player+objX],-1
	mov word [player+objY],-1
	mov byte [cs:Color],155

	call ClearScreen
	call FlipPage
	call ClearScreen

	jmp .ClMap
.Clear:	mov di,mapData				;Map lschen
	xor al,al
	mov cx,MAP_SIZE
	rep stosb

	jmp short .Loop

	;Funktion: Refresh setzen
.SetRef mov cx,[editorPosX]
	mov dx,[editorPosY]
	tileIdx cx,dx
	mov byte [mapRefresh+bx],2
	ret
		
.Loop:	mov byte [ScoreBarDirty],0
	call Draw
	call Draw
	call Draw
	call Draw
	call Draw

	;Auf ESC prfen
	cmp byte [cs:isEsc],0
	je .NoEsc
	call Sure
	jnc .NoEsc
	ret
.NoEsc:

	;Map lschen durch Druck von [Home]
	cmp byte [cs:keys+KEY_HOME],0
	je .NoHome
	call Sure
	jnc .NoHome
	
.ClMap	push ds
	pop es

	mov di,mapRefresh
	mov al,2
	mov cx,MAP_SIZE
	rep stosb
	
	jmp .Clear
.NoHome:
	;Verndern der Position bei Druck der Pfeiltasten
	xor bh,bh
	mov bl,[plKeyUp]
	cmp byte [cs:keys+bx],0
	je .NoUp

	call .SetRef
	mov ax,[editorPosY]
	dec ax
	jns .NoUpRollOver
	mov ax,MAP_HEIGHT-1
.NoUpRollOver
	mov [editorPosY],ax

.NoUp:	xor bh,bh
	mov bl,[plKeyDown]
	cmp byte [cs:keys+bx],0
	je .NoDown

	call .SetRef
	mov ax,[editorPosY]
	inc ax
	cmp ax,MAP_HEIGHT
	jb .NoDownRollOver
	xor ax,ax
.NoDownRollOver:
	mov [editorPosY],ax

.NoDown xor bh,bh
	mov bl,[plKeyLeft]
	cmp byte [cs:keys+bx],0
	je .NoLeft

	call .SetRef
	mov ax,[editorPosX]
	dec ax
	jns .NoLeftRollOver
	mov ax,MAP_WIDTH-1
.NoLeftRollOver
	mov [editorPosX],ax

.NoLeft xor bh,bh
	mov bl,[plKeyRight]
	cmp byte [cs:keys+bx],0
	je .NoRght

	call .SetRef
	mov ax,[editorPosX]
	inc ax
	cmp ax,MAP_WIDTH
	jb .NoRghtRollOver
	xor ax,ax
.NoRghtRollOver
	mov [editorPosX],ax
.NoRght:

	mov cx,[editorPosX]
	mov dx,[editorPosY]
	tileIdx cx,dx

	;Tiles bei verschiedenen Tasten setzen

%macro SetTileOnKey 2
	cmp byte [cs:keys+%1],0
	je %%Nope
	mov byte [mapData+bx],%2
	mov byte [mapRefresh+bx],2
%%Nope
%endmacro

	SetTileOnKey KEY_A,-TILAPPR
	SetTileOnKey KEY_B,-TILBLK
	SetTileOnKey KEY_D,TILDSAP

	SetTileOnKey KEY_C,TILCOIN
	SetTileOnKey KEY_E,TILEXIT
	SetTileOnKey KEY_L,TILLADR

	SetTileOnKey KEY_Z,-TILAUTL
	SetTileOnKey KEY_X,-TILAUTR

	SetTileOnKey KEY_T,TILFFR
	SetTileOnKey KEY_Y,TILFFG
	SetTileOnKey KEY_U,TILFFB
	SetTileOnKey KEY_I,TILFFY

	SetTileOnKey KEY_G,TILSWR
	SetTileOnKey KEY_H,TILSWG
	SetTileOnKey KEY_J,TILSWB
	SetTileOnKey KEY_K,TILSWY

	SetTileOnKey KEY_0,TILMAN
	SetTileOnKey KEY_1,TILSLIM
	SetTileOnKey KEY_2,TILPAC
	SetTileOnKey KEY_3,TILBALL

	SetTileOnKey KEY_LSHIFT,TILGEM
	SetTileOnKey KEY_TAB,TIL1UP
	SetTileOnKey KEY_9,-TIL1UP
	SetTileOnKey KEY_8,-TILGEM
	SetTileOnKey KEY_DEL,TILBG
	SetTileOnKey KEY_SPACE,TILLETR

	;Bei Druck von F1 Hilfe anzeigen
	cmp byte [cs:keys+KEY_F1],0
	je .NoF1
	
	mov si,editHelp
	call DispHelp

	mov di,mapRefresh			;Refresh setzen
	mov al,2
	mov cx,MAP_SIZE
	rep stosb

	jmp .Loop				;Zurck zum Editor
	
.NoF1:

	;Bei Druck von F2 Level testen

	cmp byte [cs:keys+KEY_F2],0
	bra e, .NoF2
	mov byte [maxLev],0		;Nur 1 Level (nmlich Level 0)

	push ds				;MapData nach Level0 kopieren
	pop es

	lea si,[mapData]
	lea di,[levels]
	mov cx,MAP_SIZE
	rep movsb

	mov byte [cs:Color],155
	mov ax,tilBg
	mov [tileTable+17*2],ax
	mov [tileTable+15*2],ax
	mov [tileTable+18*2],ax
	mov [tileTable+20*2],ax
	mov [tileTable+21*2],ax
	mov word [tileTable+22*2],tilBlk
	mov word [lives],'03'
	mov word [score+0],'00'
	mov word [score+2],'00'
	mov word [score+4],'00'
	pusha
	mov bp,0xffff
	call Game			;Schnell mal Game aufrufen :)
	mov word [monstNum],0
	mov word [tileTable+15*2],tilSlim
	mov word [tileTable+17*2],tilPac
	mov word [tileTable+18*2],tilBall
	mov word [tileTable+20*2],tilMan
	mov word [tileTable+21*2],tilAppr
	mov word [tileTable+22*2],tilDsAp
	xor al,al
	mov [levelDone],al
	mov [level],al
	mov [playerDead],al
	popa

	call InitLev

	mov word [player+objX],-1
	mov word [player+objY],-1

	mov si,levels			;Level0 zurck nach MapData
	mov di,mapData
	mov cx,MAP_SIZE
	rep movsb

	call ClearScreen
	call FlipPage
	call ClearScreen

.NoF2:
	;Bei Druck von F5 Level speichern, bei F7 laden
	mov bp,7
	cmp byte [cs:keys+KEY_F7],0
	jne .F5
	mov bp,5
	cmp byte [cs:keys+KEY_F5],0
	jne .F5
	jmp .NoF5

.F5	call PromptFilename 

	xor cx,cx
	mov dx,msg
	mov al,2

	cmp bp,7
	jne .Create

.Open	mov ah,fOpen
	jmp short .OpenCreateDone
.Create mov ah,fCreate
.OpenCreateDone:
	int 21h
	jc .fError

	mov bx,ax
	mov cx,MAP_SIZE
	mov dx,mapData
	cmp bp,5
	jne .Load

.Save:	mov ah,fWrite
	jmp short .LoadSaveDone
.Load:	mov ah,fRead
.LoadSaveDone:
	int 21h
	jc .fError

	mov ah,fClose
	int 21h
	jmp short .F5Done

.fError call PrintError
.IsChr	mov byte [cs:isKey],0
.WtChr	cmp byte [cs:isKey],0
	je .WtChr
		
	call ClearScoreBar
	call DrawScoreBar
	call FlipPage
	call DrawScoreBar
	call InitScoreBar	
	
	jmp short .NoF5

.F5Done	call ClearScoreBar
	call DrawScoreBar
	call FlipPage
	call DrawScoreBar
	call InitScoreBar

	mov di,levels
	mov si,mapData
	mov cx,MAP_SIZE
	rep movsb

	call InitLev
	mov word [monstNum],0
	mov word [player+objX],-1
	mov word [player+objY],-1

.NoF5:
	;Angewhltes Tile umranden

	mov ax,[editorPosX]		;cx = PixelX
	mov cx,TILE_WIDTH
	mul cx
	mov cx,ax
	
	mov ax,[editorPosY]		;dx = PixelY
	mov bx,TILE_HEIGHT
	mul bx
	mov dx,ax

	mov word [monstNum],0

	mov si,editorFrame		;Rahmen
	call PutSprite

	jmp .Loop
