	bits 16

%define _MOVE_ASM_
%include "defs.inc"

global MovePlayer
global MoveMonsters


extern keys
extern plKeyLeft
extern plKeyDown
extern plKeyRight
extern plKeyUp
extern plKeyJump
extern player
extern playerDead
extern monsters
extern monstNum

extern objMoveUp
extern objMoveDown
extern objMoveLeft
extern objMoveRight
extern objOnGround
extern objCollide
extern objAdvanceFrame
extern objSetRefresh

SEGMENT _TEXT PUBLIC ALIGN=2 CLASS=CODE

; -=( MovePlayer )=---------------------------------------------------------
; -=( Bewegt Player bei Druck von plKeyLeft, plKeyRight oder plKeyJump )=-
; --------------------------------------------------------------------------
jumpReleased	db 0			;Wurde der Jumpkey losgelassen?
jumping		db 0			;Kann die Figur im Moment springen?

GREY_PLUS equ KEY_PLUS_PAD

MovePlayer:
	pushx ax,bx,dx,si

	cmp byte [cs:keys+GREY_PLUS],0	;Graues + gedrckt?
	je .NoGreyPlus
	mov byte [playerDead],1		;Spieler tot :(

.NoGreyPlus:

	mov dl,1			;Advanceflag

	xor bh,bh
	mov bl,[plKeyJump]

	lea si,[player]

	call objSetRefresh

	cmp byte [si+objTrapped],0	;Figur eingesperrt?
	je .NoPlTrap
	mov byte [si+objTrapped],0
	mov byte [playerDead],1		;Tot :(

.NoPlTrap

	cmp byte [cs:keys+bx],0		;JumpKey losgelassen?
	jnz .jPressed
	mov byte [cs:jumpReleased],1	;Releaseflag setzen
	mov byte [cs:jumping],0		;Jumpflag lschen

	cmp byte [si+objOnLadder],0	;Spieler auf Leiter?
	jz .jPressed
	jmp .onGround			;Nicht fallen
.jPressed:

	call objOnGround		;Steht Spieler auf festem Grund?
	or dh,dh
	jnz .onGround			;Nicht fallen

	;Fallen
	mov ax,[si+objSpeedFall]
	add ax,[si+objGravity]		;Immer schneller fallen
	mov [si+objGravity],ax
	mov dl,10			;Beim Fallen keine Gehbewegung
	
	call objMoveDown

	jmp .fallEnd

	;Figur steht auf festem Grund
.onGround:
	cmp dh,-TILAUTL			;Laufband links
	jne .noAutL
	mov ax,32			;1/2 Pixel nach rechts
	call objMoveLeft
.noAutL cmp dh,-TILAUTR			;Laufband rechts
	jne .noAutR
	mov ax,32			;1/2 Pixel nach rechts
	call objMoveRight
.noAutR:

	mov byte [cs:jumping],0		;Jumpflag lschen

	;Jumpflag setzen, wenn Releaseflag gesetzt ist
	cmp byte [cs:jumpReleased],0	;Releaseflag nicht gesetzt?
	jz .fallEnd			;Weiter
	mov byte [cs:jumping],1		;Jumpflag setzen
.fallEnd:

	mov ax,[si+objGravity]		;Gravity >= JumpSpeed ?
	cmp ax,[si+objSpeedJump]
	jae .noJump			;Kein Jump

	cmp byte [cs:keys+bx],0		;Jumpkey nicht gedrckt?
	jz .noJump			;Kein Jump

	cmp byte [cs:jumping],0		;Jumpflag nicht gesetzt?
	jz .noJump			;Kein Jump

	;Figur springt
	mov word [si+objFrame],0	;Frame 0 setzen
	mov ax,[si+objSpeedJump]	;Nach oben bewegen
	call objMoveUp
	mov dl,10			;Beim Springen keine Gehbewegung
	mov byte [cs:jumpReleased],0	;Weil Springtaste gedrckt ist jr=0
	jmp .noLadr			;Beim Klettern kein Sprung
.noJump:
	cmp byte [si+objOnLadder],0	;Steht Spieler auf Leiter?
	jz .noLadr
	mov byte [si+objOnLadder],0

	mov word [si+objGravity],0
	
	mov bl,[plKeyUp]
	cmp byte [cs:keys+bx],0		;Rauf gedrckt?
	jz .noUp
	mov ax,[si+objSpeedX]		;Klettergeschwindigkeit = Laufgeschw.
	call objMoveUp
	mov word [si+objFace],2		;Kletterbewegung
	add dl,5
.noUp:
	mov bl,[plKeyDown]
	cmp byte [cs:keys+bx],0		;Runter gedrckt?
	jz .noDown
	mov ax,[si+objSpeedX]		;Klettergeschwindigkeit = Laufgeschw.
	call objMoveDown
	mov word [si+objFace],2		;Kletterbewegung
	add dl,5
.noDown:
.noLadr:
	mov bl,[plKeyLeft]		;bl = index
	cmp byte [cs:keys+bx],0		;Links gedrckt?
	jz .noLeft

	;Bewegung nach links
	mov ax,[si+objSpeedX]		;Nach links bewegen
	call objMoveLeft
	cmp dl,5
	jae .noLeft			;Beim Klettern Kletterbewegung
	mov word [si+objFace],0		;Nach links schauen
	inc dl				;Gehbewegung
.noLeft:
	mov bl,[plKeyRight]		;bl = index
	cmp byte [cs:keys+bx],0		;Rechts gedrckt?
	jz .noRght

	;Bewegung nach rechts
	mov ax,[si+objSpeedX]		;Nach rechts bewegen
	call objMoveRight
	cmp dl,5
	jae .noRght			;Beim Klettern Kletterbewegung
	mov word [si+objFace],1		;Nach rechts schauen
	inc dl				;Gehbewegung
.noRght:
	cmp dl,10			;Soll advanced werden?
	jae .noAdv			;Nein
	cmp dl,5
	jae .adv			;Ja
	cmp dl,2
	jne .noAdv			;Nein
.adv:	call objAdvanceFrame		;Advancen
.noAdv:	
	mov byte [si+objOnLadder],0

	popx si,dx,bx,ax
	ret

; -=( MoveMonsters )=-------------------------------------------------------
; -=( Bewegt die Monster durch AI )=-
; --------------------------------------------------------------------------
MoveMonsters:
	pusha

	cmp word [monstNum],0		;Nix zu tun
	bra e, MMBye

	lea si,[monsters]		;1.Monster
	xor cx,cx

NextMon	call objSetRefresh

	cmp byte [si+objTrapped],0
	mov byte [si+objTrapped],0
	bra ne, MoveDone

	cmp word [si+objType],1		;;; Slime ;;;
	jne noSlime

	objDir EQU objSpeedJump
Slime:	
	;Beim Slime wird objSpeedJump als Richtung missbraucht:
	; 0 - links, 1 - rechts


	call objOnGround
	or dh,dh
	jnz .onGround			;Kein Fallen

	cmp byte [si+objOnLadder],0	;Auf Leiter?
	mov byte [si+objOnLadder],0
	jne .onGround			;Nicht fallen

	;Fallen
	mov ax,[si+objSpeedFall]
	add ax,[si+objGravity]		;Immer schneller Fallen
	mov [si+objGravity],ax

	call objMoveDown
	jmp .fallEnd
.onGround:
	cmp dh,-TILAUTL			;Laufband links
	jne .NoAutL
	mov ax,32			;1/2 Pixel nach links
	call objMoveLeft
.NoAutL cmp dh,-TILAUTR			;Laufband rechts
	jne .NoAutR
	mov ax,32			;1/2 Pixel nach rechts
	call objMoveRight
.NoAutR

.move	mov ax,[si+objDir]
	or ax,ax
	mov ax,[si+objSpeedX]
	jz .left

.right:	call objMoveRight		;Rechts
	bra nc, .moveEnd		;Bewegung ist erfolgt
	mov word [si+objDir],0		;Obj angestoen, umdrehen
	jmp .moveEnd

.left:	call objMoveLeft		;Links
	jnc .moveEnd			;Bewegung ist erfolgt
	mov word [si+objDir],1		;Obj angestoen, umdrehen

.moveEnd:
.fallEnd:
	jmp MoveDone

noSlime	cmp word [si+objType],2		;;; PacMonster ;;;
	jne noPac

Pac:
	mov ax,[si+objSpeedX]

	mov bx,[si+objFace]		;Richtung bestimmen
	cmp bx,0
	je .Right
	cmp bx,1
	je .Down
	cmp bx,2
	je .Left
	cmp bx,3
	je .Up

.Right 	call objMoveRight		;Rechts
	jnc .MoveEnd			;Bewegung geglckt?
	inc word [si+objFace]		;Obj angestoen, Richtung ndern
	jmp short .MoveEnd

.Down	call objMoveDown		;Runter
	jnc .MoveEnd			;Bewegung geglckt?
	inc word [si+objFace]		;Angestoen, Richtung ndern
	jmp short .MoveEnd

.Left	call objMoveLeft		;Links
	jnc .MoveEnd			;Bewegung geglckt?
	inc word [si+objFace]		;Angestoen, Richtung ndern
	jmp short .MoveEnd

.Up	call objMoveUp			;Hoch
	jnc .MoveEnd			;Bewegung geglckt?
	mov word [si+objFace],0		;Angestoen, Richtung ndern

.MoveEnd:

noPac	cmp word [si+objType],3		;;; Ball ;;;
	jne noBall

objLR	equ objSpeedFall		;X-Richtung (0=links, 1=rechts)
objUD	equ objGravity			;Y-Richtung (0=oben,  1=unten )

Ball:	mov ax,[si+objLR]
	or ax,ax
	mov ax,[si+objSpeedX]
	jnz .Right

.Left	call objMoveLeft
	jnc .DoneLR			;Bewegung geglckt, weiter!
	mov word [si+objLR],1		;Nach rechts wenden
	jmp short .DoneLR

.Right	call objMoveRight
	jnc .DoneLR			;Bewegung geglckt, weiter.
	mov word [si+objLR],0		;Nach links wenden
.DoneLR:

	mov bx,[si+objUD]
	or bx,bx
	jnz .Down

.Up	call objMoveUp
	jnc .DoneUD			;Bewegung geglckt, weiter...
	mov word [si+objUD],1		;Nach unten wenden
	jmp short .DoneUD

.Down	call objMoveDown
	jnc .DoneUD			;Bewegung geglckt, weiter
	mov word [si+objUD],0
.DoneUD:

noBall:	

MoveDone:
	mov di,player
	call objCollide
	jnc .noCol			;Kollision mit Spieler?
	mov byte [playerDead],1		;Figur tot :(

.noCol	call objAdvanceFrame
CollCheckDone:

	inc cx
	cmp cx,[monstNum]		;Waren das alle Monster?
	jae MMBye			;Ja

	add si,obj_size			;Nchstes Monster
	jmp NextMon

MMBye	popa
	ret
