	bits 16

%define _OBJ_ASM_
%include "defs.inc"

global objAdvanceFrame
global objDraw
global objMoveUp
global objMoveDown
global objMoveLeft
global objMoveRight
global objCollide
global objOnGround
global objSetRefresh


extern mapData
extern mapRefresh
extern sndPtr
extern sndCount
extern sndCoin
extern sndAppr
extern ffR
extern ffG
extern ffB
extern ffY

extern DoSpecial

SEGMENT	_TEXT PUBLIC ALIGN=2 CLASS=CODE

; -=( objAdvanceFrame )=----------------------------------------------------
; -=( Erhht objAdvCount um 1; wenn objAdvCount >= sprAdvDelay wird
;     objAdvCount auf 0 gesezt und objFrame erhht,
;     wenn objFrame >= sprNoOfFrames wird objFrame auf 0 gesetzt     )=-
; -=( IN: ds:si - obj )=-
; --------------------------------------------------------------------------
objAdvanceFrame:
	push ax
	push si
	push di
	
	mov di,[si+objSpritePtr]	;di = sprite
	inc byte [si+objAdvCount]	;AdvCount erhhen
	mov al,[di+sprAdvDelay]
	cmp [si+objAdvCount],al		;AdvCount < AdvDelay ?
	jb .Return			;Raus
	
	mov byte [si+objAdvCount],0	;AdvCount = 0
	inc word [si+objFrame]		;objFrame erhhen
	mov ax,[di+sprNoOfFrames]
	cmp [si+objFrame],ax		;Frame < NoOfFrames?
	jb .Return			;Raus
	mov word [si+objFrame],0	;Sonst Frame = 0

.Return:
	pop di
	pop si
	pop ax
	ret

; -=( objDraw )=------------------------------------------------------------
; -=( Zeichnet ein obj an seinen X- und Y-Koordinaten in den Buffer )=-
; -=( IN: ds:si - obj, 
; -=( cx - xDisplacement in Pixeln!!!, dx - yDisplacement in Pixeln!!! )=-
; --------------------------------------------------------------------------
align 2
objDraw:
	pusha

	mov di,[si+objSpritePtr]	;di = sprite


	push cx
	push dx

	;Offset des Frames errechnen
	mov ax,[si+objFace]
	mov bx,[di+sprFaceSize]
	mul bx				;ax = Face*FaceSize
	mov cx,ax			;cx = ax
	mov ax,[si+objFrame]
	mov bx,[di+sprFrameSize]
	mul bx				;ax = Frame*FrameSize
	add ax,cx			;ax += cx
	mov bx,ax

	pop dx
	pop cx
	
	;Sprite anzeigen
	mov ax,[si+objX]
	shr ax,6			;da Koordinaten in P/64 (s.o.)
	add cx,ax			;Displacement
	mov ax,[si+objY]
	shr ax,6
	add dx,ax			;Displacement
	lea si,[di+sprData+bx]		;si = aktueller Frame
	call PutSprite

	popa
	ret


; -=( chkApBlk )=-----------------------------------------------------------
; -=( Ersetzt Versteckten Block bei Berhrung durch einen Block )=-
; -=( IN: ds:di - mapData, bx - index, si - obj )=-
; --------------------------------------------------------------------------
chkApBlk:
	cmp byte [di+bx],-TILAPPR	;Versteckter Block?
	jne .NoApBlk
	cmp word [si+objType],0		;Nur Player
	jne .NoApBlk
	mov byte [di+bx],-TILBLK	;Wird zu normalem Block
	mov byte [mapRefresh+bx],3	;Refresh, da Figur den Block nie betr.
	mov word [sndPtr],sndAppr
	mov word [sndCount],0
.NoApBlk:
	ret

; -=( chkFF )=--------------------------------------------------------------
; -=( Prft, ob ein Tile ein ForceField ist UND es aktiviert ist )=-
; -=( IN: ds:di - mapData,bx - index )=-
; -=( OUT: zf=0 (nz) wenn aktiviertes ForceField )=-
; --------------------------------------------------------------------------
chkFF:	push ax

	mov al,[di+bx]
.chkR:	cmp al,TILFFR
	jne .chkG
	mov al,[ffR]
	or al,al
	jmp short .Done
.chkG:	cmp al,TILFFG
	jne .chkB
	mov al,[ffG]
	or al,al
	jmp short .Done
.chkB:	cmp al,TILFFB
	jne .chkY
	mov al,[ffB]
	or al,al
	jmp short .Done
.chkY:	cmp al,TILFFY
	jne .stZ
	mov al,[ffY]
	or al,al
	jmp short .Done

.stZ	xor al,al
.Done	pop ax
	ret

;-=( objMove (Up,Down,Left,Right) )=-----------------------------------
; -=( Bewegt ein obj nach , achtet dabei auf unbegehbare Blcke )=-
; -=( IN: ax - P/64-Zahl, um die verschoben werden soll, si - obj   )=-
; -=( OUT: cf gesetzt, wenn obj auf unbegehbaren Block stt )=-
; --------------------------------------------------------------------------
align 2
objMoveUp:
	clc
	pushx ax,bx,cx,dx,di,bp
	mov di,[si+objSpritePtr]

	mov bp,[si+objY]
	sub bp,ax
	cmp bp,0			;Top < 0?
	bra l,.outOfBounds
	
	;Auf unzugngliche Tiles pruefen

	;bx = tileLeft
	mov ax,[si+objX]
	shr ax,6
	mov cx,TILE_WIDTH
	xor dx,dx
	div cx
	mov bx,ax

	;ax = tileRight
	mov ax,[si+objX]
	shr ax,6
	add ax,[di+sprData]
	dec ax
	xor dx,dx
	div cx
	
	;cx = tileTop
	push ax
	mov ax,bp
	shr ax,6
	xor dx,dx
	mov cx,TILE_HEIGHT
	div cx
	mov cx,ax
	pop ax

	lea di,[mapData]
	;for(bx=tileLeft;bx<=tileRight;bx++)
.loop:	push bx
	tileIdx bx,cx
	cmp byte [di+bx],0		;Tile unzugaenglich?
	js .notWalkable
	call chkFF
	jnz .notWalkable
	pop bx
	
	inc bx
	cmp bx,ax
	jle .loop

	jmp short .finish
	
.outOfBounds:
	xor bp,bp			;Top = 0
	mov ax,[si+objSpeedJump]	;Sprung verhindern
	inc ax
	mov [si+objGravity],ax
	stc
	jmp short .finish
.notWalkable:
	call chkApBlk

	;1 Tile nach unten verschieben (funzt, wenn Param ax <= TileHeight)
	pop bx
	mov ax,cx
	inc ax
	mov cx,TILE_HEIGHT
	mul cx
	shl ax,6
	mov bp,ax

	mov ax,[si+objSpeedJump]	;Sprung verhindern
	inc ax
	mov [si+objGravity],ax
	stc
.finish:
	mov [si+objY],bp		;Zurckschreiben

	popx bp,di,dx,cx,bx,ax
	ret

align 2
objMoveDown:
	clc
	pushx ax,bx,cx,dx,di,bp
	mov di,[si+objSpritePtr]

	add ax,[si+objY]
	mov bp,ax
	
	shr ax,6
	add ax,[di+sprData+2]
	cmp ax,(MAP_HEIGHT*TILE_HEIGHT)	;Bottom >= maxHeight?
	bra ge,.outOfBounds
	
	;Auf unzugaengliche Tiles pruefen

	mov byte [si+objOnTile],0
	
	;bx = tileLeft
	mov ax,[si+objX]
	shr ax,6

	mov cx,TILE_WIDTH
	xor dx,dx
	div cx
	mov bx,ax

	;ax = tileRight
	mov ax,[si+objX]
	shr ax,6
	add ax,[di+sprData]	
	dec ax
	xor dx,dx
	div cx
	
	;cx = tileBottom
	push ax
	mov ax,bp
	shr ax,6
	add ax,[di+sprData+2]
	xor dx,dx
	mov cx,TILE_HEIGHT
	div cx
	mov cx,ax
	pop ax

	push di
	lea di,[mapData]		;di = mapData
	;for(bx=tileLeft;bx<=tileRight;bx++)
.loop:	push bx
	tileIdx bx,cx
	cmp byte [di+bx],0		;Tile unzugaenglich?
	js .notWalkable
	call chkFF
	jnz .notWalkable
	pop bx
	
	inc bx
	cmp bx,ax
	jle .loop

	pop di
	jmp short .finish
	
.outOfBounds:
	mov ax,(MAP_HEIGHT*TILE_HEIGHT)
	sub ax,[di+sprData+2]		;Bottom = MaxHeight
	shl ax,6
	mov bp,ax
	stc
	jmp short .finish
	
.notWalkable:
	call chkApBlk

	mov bl,[di+bx]
	mov [si+objOnTile],bl		;ObjOnGround informieren
	pop bx

	pop di
;1 Tile nach oben verschieben (funzt, wenn Param ax <= TileHeight)
	mov ax,cx
	mov cx,TILE_HEIGHT
	mul cx
	sub ax,[di+sprData+2]
	shl ax,6
	mov bp,ax
	stc

.finish:
	mov [si+objY],bp		;Zurckschreiben

	popx bp,di,dx,cx,bx,ax
	ret

align 2
objMoveLeft:
	clc
	pushx ax,bx,cx,dx,di,bp
	mov di,[si+objSpritePtr]

	mov bp,[si+objX]
	sub bp,ax
	cmp bp,0			;Left < 0?
	bra l,.outOfBounds
	
	;Auf unzugaengliche Tiles pruefen

	;bx = tileTop
	mov ax,[si+objY]
	shr ax,6
	mov cx,TILE_HEIGHT
	xor dx,dx
	div cx
	mov bx,ax

	;ax = tileBottom
	mov ax,[si+objY]
	shr ax,6
	add ax,[di+sprData+2]
	dec ax
	xor dx,dx
	div cx
	
	;cx = tileLeft
	push ax
	mov ax,bp
	shr ax,6
	xor dx,dx
	mov cx,TILE_WIDTH
	div cx
	mov cx,ax
	pop ax

	lea di,[mapData]		;di = mapData
	;for(bx=tileTop;bx<=tileBottom;bx++)
.loop:	push bx
	tileIdx cx,bx
	cmp byte [di+bx],0		;Tile unzugaenglich?
	js .notWalkable
	call chkFF
	jnz .notWalkable
	pop bx
	
	inc bx
	cmp bx,ax
	jle .loop

	jmp short .finish
	
.outOfBounds:
	xor bp,bp			;Left = 0
	stc
	jmp short .finish
.notWalkable:
	call chkApBlk

	;1 Tile nach rechts verschieben (funzt, wenn Param ax <= TileWidth)
	pop bx
	mov ax,cx
	inc ax
	mov cx,TILE_WIDTH
	mul cx
	shl ax,6
	mov bp,ax
	stc

.finish:
	mov [si+objX],bp		;Zurckschreiben

	popx bp,di,dx,cx,bx,ax
	ret

align 2
objMoveRight:
	clc
	pushx ax,bx,cx,dx,di,bp
	mov di,[si+objSpritePtr]

	add ax,[si+objX]
	mov bp,ax
	
	shr ax,6
	add ax,[di+sprData]
	cmp ax,(MAP_WIDTH*TILE_WIDTH)	;Width >= maxHeight?
	bra ge, .outOfBounds
	
	;Auf unzugaengliche Tiles pruefen

	;bx = tileTop
	mov ax,[si+objY]
	shr ax,6
	mov cx,TILE_HEIGHT
	xor dx,dx
	div cx
	mov bx,ax

	;ax = tileBottom
	mov ax,[si+objY]
	shr ax,6
	add ax,[di+sprData+2]
	dec ax
	xor dx,dx
	div cx
	
	;cx = tileRight
	push ax
	mov ax,bp
	shr ax,6
	add ax,[di+sprData]
	dec ax
	xor dx,dx
	mov cx,TILE_HEIGHT
	div cx
	mov cx,ax
	pop ax

	push di
	lea di,[mapData]		;di = mapData
	;for(bx=tileTop;bx<=tileBottom;bx++)
.loop:	push bx
	tileIdx cx,bx
	cmp byte [di+bx],0		;Tile unzugaenglich?
	js .notWalkable
	call chkFF
	jnz .notWalkable
	pop bx
	
	inc bx
	cmp bx,ax
	jle .loop

	pop di
	jmp short .finish
	
.outOfBounds:
	mov ax,(MAP_WIDTH*TILE_WIDTH)
	sub ax,[di+sprData]		;Right = MaxHeight
	shl ax,6
	mov bp,ax
	stc
	jmp short .finish
	
.notWalkable:
	call chkApBlk

	pop bx
	pop di
	
	;1 Tile nach links verschieben (funzt, wenn Param ax <= TileWidth)
	mov ax,cx
	mov cx,TILE_WIDTH
	mul cx
	sub ax,[di+sprData]
	shl ax,6
	mov bp,ax
	stc

.finish:
	mov [si+objX],bp		;Zurckschreiben

	popx bp,di,dx,cx,bx,ax
	ret

; -=( objCollide )=---------------------------------------------------------
; -=( Prft ob sich zwei objs berschneiden )=-
; -=( IN: ds:si, ds:di - objs )=-
; -=( OUT: cf bei Kollision gesetzt )=-
; --------------------------------------------------------------------------
align 2
objCollide:
	pusha

	;ax = left, bx = right von obj1;
	;cx = left, dx = right von obj2;

	mov ax,[si+objX]
	mov cx,[di+objX]

	mov bp,[si+objSpritePtr]
	mov bx,[ds:bp+sprData]
	shl bx,6
	add bx,ax
	dec bx

	mov bp,[di+objSpritePtr]
	mov dx,[ds:bp+sprData]
	shl dx,6
	add dx,cx
	dec dx

	;Formel: left1 < right2 && right1 > left2
	
	cmp ax,dx
	jnb .noCol
	cmp bx,cx
	jna .noCol

	;ax = top, bx = bottom von obj1;
	;cx = top, dx = bottom von obj2;

	mov ax,[si+objY]
	mov cx,[di+objY]

	mov dx,[ds:bp+sprData+2]
	shl dx,6
	add dx,cx

	mov bp,[si+objSpritePtr]
	mov bx,[ds:bp+sprData+2]
	shl bx,6
	add bx,ax

	;Formel: top1 < bottom2 && bottom1 > top2
	
	cmp ax,dx
	jnb .noCol
	cmp bx,cx
	jna .noCol

.col:	stc
	jmp short .bye
.noCol	clc
.bye:	popa
	ret
	
; -=( objOnGround )=--------------------------------------------------------
; -=( Stellt fest, ob obj auf solidem Grund steht )=-
; -=( IN: ds:si - obj, OUT: dh != 0 wenn am Grund )=-
; --------------------------------------------------------------------------
align 2
objOnGround:
	pushx ax,di

	mov ax,[si+objY]		;ax = Bottom
	shr ax,6			;da in P/64
	mov di,[si+objSpritePtr]
	add ax,[di+sprData+2]
	dec ax
	
	cmp ax,(MAP_HEIGHT*TILE_HEIGHT - 1)
	mov dh,255
	bra e,.onGround

	xor ax,ax
	call objMoveDown		;Setzt onTile
	mov al,[si+objOnTile]
	cmp al,0
	jz .notOnGround
	mov dh,al

.onGround:
	mov word [si+objGravity],0
	jmp short .bye

.notOnGround:
	xor dh,dh

.bye:	popx di,ax
	ret

; -=( objSetRefresh )=------------------------------------------------------
; -=( Setzt den RefreshFlag aller vom obj belegten Tiles auf 3 )=-
; -=( IN: ds:si - obj )=-
; --------------------------------------------------------------------------
align 2
objSetRefresh:
	pusha

	cmp byte [si+objOnSwitch],0
	je .NoDec
	dec byte [si+objOnSwitch]
.NoDec	mov di,[si+objSpritePtr]

	;ax = tileLeft
	mov ax,[si+objX]
	shr ax,6
	mov cx,TILE_WIDTH
	xor dx,dx
	div cx

	;bx = tileRight
	push ax
	mov ax,[si+objX]
	shr ax,6
	add ax,[di+sprData]
	dec ax
	xor dx,dx
	div cx
	mov bx,ax
	pop ax

	push ax

	;ax = tileTop
	mov ax,[si+objY]
	shr ax,6
	mov cx,TILE_HEIGHT
	xor dx,dx
	div cx

	;dx = tileBottom
	push ax
	mov ax,[si+objY]
	shr ax,6
	add ax,[di+sprData+2]
	dec ax
	xor dx,dx
	div cx
	mov dx,ax
	pop ax

	mov cx,ax			;cx = tileTop

	pop ax

	;for(cx = tileTop; cx <= tileBottom; cx++)
.yLoop:	mov di,ax
	  ;for(di = tileLeft; di <= tileRight; di++)
.xLoop: push bx
	tileIdx di,cx
	mov byte [mapRefresh+bx],3

	push ax
	mov al,[mapData+bx]
	call DoSpecial			;Special-Funk aufrufen
	pop ax

	pop bx
	inc di
	cmp di,bx
	jbe .xLoop

	inc cx
	cmp cx,dx
	jbe .yLoop

	popa
	ret